=== debian/changelog ===
libmyhtml (4.0.5) stable; urgency=medium

  * Initial release

 -- Alexander Borisov <lex.borisov@gmail.com>  Tue, 21 Mar 2017 14:46:45 +0200
